////////////////////////////////////////////////////
// nopeustestin_testaaja.h
////////////////////////////////////////////////////
// Copyright 2019-2020 Jaakko Kairus
// jaakko@kair.us
//
// You may freely use and modify this software for personal use.
// Commercial use of this software or parts of it is prohibited
// without written permission from author.
// DISCLAIMER: This software comes with ABSOLUTELY NO WARRANTY
//
// For more information about this project see project web page at
// http://kair.us/projects/nopeustesti/index.html
/////////////////////////////////////////////////////

#include <16F15355.h>
#device ADC=10
#DEVICE PASS_STRINGS=IN_RAM // allows passing constant char arrays to saa1064.h function
                             // copies string from rom to ram when needed
//#fuses INTRC_IO,NOWDT,NOPROTECT,NOLVP,NODEBUG,NOBROWNOUT,NOPLLEN,CPUDIV1,PUT,NOMCLR
#fuses NOPPS1WAY,NOMCLR
#use delay(internal=16MHz)
#pin_select CCP1OUT=PIN_B4
#pin_select TX1=PIN_B6
#pin_select RX1=PIN_B7
#use pwm(CCP1, TIMER=2, FREQUENCY=400, PWM_OFF)
#use rs232(baud=115200, UART1)
#use FAST_IO(a)
#use FAST_IO(b)
#use FAST_IO(c)
#use FAST_IO(e)

#byte INTF = 0x70C
#bit TMR0IF = INTF.5

#define ULN2003_DRIVE       // PIC output is driven high to turn on lamp. If you want to control button leds directly by grounding cathode via PIC pin, comment this line

//////////////////////////////////////////////////
// Pin defines for button inputs and lamp outputs
//////////////////////////////////////////////////

#define BLUE_LAMP PIN_B0
#define YELLOW_LAMP PIN_B1
#define GREEN_LAMP PIN_B2
#define RED_LAMP PIN_B3
#define BLUE_BUTTON PIN_A3
#define YELLOW_BUTTON PIN_A2
#define GREEN_BUTTON PIN_A1
#define RED_BUTTON PIN_A0

#ifdef ULN2003_DRIVE
#define LAMP_ON output_high
#define LAMP_OFF output_low
#else
#define LAMP_ON output_low
#define LAMP_OFF output_high
#endif

#define BUZZER_P PIN_B4
#define BUZZER_SPK_N PIN_B5

unsigned int16 const lamp[4] = {BLUE_LAMP, YELLOW_LAMP, GREEN_LAMP, RED_LAMP};


/////////////////////////////
// Global variables
////////////////////////////

int8 debounce = 0;
int8 new_press=0;

typedef enum {
   BUT_BLUE = 0,
   BUT_YELLOW = 1,
   BUT_GREEN = 2,
   BUT_RED = 3,
   BUT_NONE
} BUTTONS;
BUTTONS current_button = BUT_NONE;
BUTTONS last_button = BUT_NONE;


//////////////////////////
// Function prototypes
//////////////////////////

void alloff(void);
void litbutton(int color);

